<?php

$dal_info = array();

/**
 * User API function
 * @param String sql
 */
function UsersTableName()
{
	global $cman;
	$connection = $cman->getForLogin();
	return $connection->addTableWrappers("utilisateur");
}

/**
 * User API function
 * It uses the default db connection
 * @param String dalSQL
 */
function CustomQuery($dalSQL)
{
	$connection = getDefaultConnection();
	$result = $connection->query( $dalSQL );
	if($result)
		return $result;
}

/**
 * User API function
 * It uses the default db connection 
 * @param String sql
 */
function DBLookup($sql)
{
	$connection = getDefaultConnection();
	$data = $connection->query( $sql )->fetchAssoc();

	if( $data )
		return reset($data);
	  
	return null;
}

/**
  * Data Access Layer.
  */
class tDAL
{
	var $tblmastation_at_localhost__achat;
	var $tblmastation_at_localhost__annee_exo;
	var $tblmastation_at_localhost__article;
	var $tblmastation_at_localhost__bouteillegaz;
	var $tblmastation_at_localhost__caisse;
	var $tblmastation_at_localhost__carburant;
	var $tblmastation_at_localhost__client;
	var $tblmastation_at_localhost__codebarre;
	var $tblmastation_at_localhost__commande;
	var $tblmastation_at_localhost__compte_frs;
	var $tblmastation_at_localhost__creance;
	var $tblmastation_at_localhost__cuve;
	var $tblmastation_at_localhost__date_stock;
	var $tblmastation_at_localhost__dernierindex;
	var $tblmastation_at_localhost__dette_frs;
	var $tblmastation_at_localhost__famille;
	var $tblmastation_at_localhost__fonction;
	var $tblmastation_at_localhost__fournisseur;
	var $tblmastation_at_localhost__frs_charges;
	var $tblmastation_at_localhost__frs_produits;
	var $tblmastation_at_localhost__hisconnex;
	var $tblmastation_at_localhost__historisation;
	var $tblmastation_at_localhost__jauge_du_mois;
	var $tblmastation_at_localhost__jaugecuve;
	var $tblmastation_at_localhost__le_solde_frs;
	var $tblmastation_at_localhost__les_soldes;
	var $tblmastation_at_localhost__ligne_achat;
	var $tblmastation_at_localhost__ligne_vente;
	var $tblmastation_at_localhost__lignecommande;
	var $tblmastation_at_localhost__lignelivraison;
	var $tblmastation_at_localhost__livraisoncommande;
	var $tblmastation_at_localhost__mouvement_stock;
	var $tblmastation_at_localhost__naturetransaction;
	var $tblmastation_at_localhost__partenaire;
	var $tblmastation_at_localhost__personnel;
	var $tblmastation_at_localhost__pompe;
	var $tblmastation_at_localhost__prixachat;
	var $tblmastation_at_localhost__prixcarburant;
	var $tblmastation_at_localhost__profil;
	var $tblmastation_at_localhost__quart;
	var $tblmastation_at_localhost__recette_du_jour;
	var $tblmastation_at_localhost__regt_frs;
	var $tblmastation_at_localhost__relevepompe;
	var $tblmastation_at_localhost__serveuremail;
	var $tblmastation_at_localhost__solde_frs_jour;
	var $tblmastation_at_localhost__solde_par_jour;
	var $tblmastation_at_localhost__station;
	var $tblmastation_at_localhost__stationsodiserv1_audit;
	var $tblmastation_at_localhost__stocks;
	var $tblmastation_at_localhost__typecaisse;
	var $tblmastation_at_localhost__typemouvement;
	var $tblmastation_at_localhost__utilisateur;
	var $tblmastation_at_localhost__vente_du_jour;
	var $tblmastation_at_localhost__vente_du_mois;
	var $tblmastation_at_localhost__ventearticle;
	var $tblmastation_at_localhost__ventepompe;
	var $tblmastation_at_localhost__versement_du_jour;
	var $lstTables;
	var $Table = array();

	function FillTablesList()
	{
		if($this->lstTables)
			return;
		$this->lstTables[] = array("name" => "achat", "varname" => "mastation_at_localhost__achat", "altvarname" => "achat", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "annee_exo", "varname" => "mastation_at_localhost__annee_exo", "altvarname" => "annee_exo", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "article", "varname" => "mastation_at_localhost__article", "altvarname" => "article", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "bouteillegaz", "varname" => "mastation_at_localhost__bouteillegaz", "altvarname" => "bouteillegaz", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "caisse", "varname" => "mastation_at_localhost__caisse", "altvarname" => "caisse", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "carburant", "varname" => "mastation_at_localhost__carburant", "altvarname" => "carburant", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "client", "varname" => "mastation_at_localhost__client", "altvarname" => "client", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "codebarre", "varname" => "mastation_at_localhost__codebarre", "altvarname" => "codebarre", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "commande", "varname" => "mastation_at_localhost__commande", "altvarname" => "commande", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "compte_frs", "varname" => "mastation_at_localhost__compte_frs", "altvarname" => "compte_frs", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "creance", "varname" => "mastation_at_localhost__creance", "altvarname" => "creance", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "cuve", "varname" => "mastation_at_localhost__cuve", "altvarname" => "cuve", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "date_stock", "varname" => "mastation_at_localhost__date_stock", "altvarname" => "date_stock", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "dernierindex", "varname" => "mastation_at_localhost__dernierindex", "altvarname" => "dernierindex", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "dette_frs", "varname" => "mastation_at_localhost__dette_frs", "altvarname" => "dette_frs", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "famille", "varname" => "mastation_at_localhost__famille", "altvarname" => "famille", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "fonction", "varname" => "mastation_at_localhost__fonction", "altvarname" => "fonction", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "fournisseur", "varname" => "mastation_at_localhost__fournisseur", "altvarname" => "fournisseur", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "frs_charges", "varname" => "mastation_at_localhost__frs_charges", "altvarname" => "frs_charges", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "frs_produits", "varname" => "mastation_at_localhost__frs_produits", "altvarname" => "frs_produits", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "hisconnex", "varname" => "mastation_at_localhost__hisconnex", "altvarname" => "hisconnex", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "historisation", "varname" => "mastation_at_localhost__historisation", "altvarname" => "historisation", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "jauge_du_mois", "varname" => "mastation_at_localhost__jauge_du_mois", "altvarname" => "jauge_du_mois", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "jaugecuve", "varname" => "mastation_at_localhost__jaugecuve", "altvarname" => "jaugecuve", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "le_solde_frs", "varname" => "mastation_at_localhost__le_solde_frs", "altvarname" => "le_solde_frs", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "les_soldes", "varname" => "mastation_at_localhost__les_soldes", "altvarname" => "les_soldes", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "ligne_achat", "varname" => "mastation_at_localhost__ligne_achat", "altvarname" => "ligne_achat", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "ligne_vente", "varname" => "mastation_at_localhost__ligne_vente", "altvarname" => "ligne_vente", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "lignecommande", "varname" => "mastation_at_localhost__lignecommande", "altvarname" => "lignecommande", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "lignelivraison", "varname" => "mastation_at_localhost__lignelivraison", "altvarname" => "lignelivraison", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "livraisoncommande", "varname" => "mastation_at_localhost__livraisoncommande", "altvarname" => "livraisoncommande", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "mouvement_stock", "varname" => "mastation_at_localhost__mouvement_stock", "altvarname" => "mouvement_stock", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "naturetransaction", "varname" => "mastation_at_localhost__naturetransaction", "altvarname" => "naturetransaction", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "partenaire", "varname" => "mastation_at_localhost__partenaire", "altvarname" => "partenaire", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "personnel", "varname" => "mastation_at_localhost__personnel", "altvarname" => "personnel", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "pompe", "varname" => "mastation_at_localhost__pompe", "altvarname" => "pompe", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "prixachat", "varname" => "mastation_at_localhost__prixachat", "altvarname" => "prixachat", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "prixcarburant", "varname" => "mastation_at_localhost__prixcarburant", "altvarname" => "prixcarburant", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "profil", "varname" => "mastation_at_localhost__profil", "altvarname" => "profil", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "quart", "varname" => "mastation_at_localhost__quart", "altvarname" => "quart", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "recette_du_jour", "varname" => "mastation_at_localhost__recette_du_jour", "altvarname" => "recette_du_jour", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "regt_frs", "varname" => "mastation_at_localhost__regt_frs", "altvarname" => "regt_frs", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "relevepompe", "varname" => "mastation_at_localhost__relevepompe", "altvarname" => "relevepompe", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "serveuremail", "varname" => "mastation_at_localhost__serveuremail", "altvarname" => "serveuremail", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "solde_frs_jour", "varname" => "mastation_at_localhost__solde_frs_jour", "altvarname" => "solde_frs_jour", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "solde_par_jour", "varname" => "mastation_at_localhost__solde_par_jour", "altvarname" => "solde_par_jour", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "station", "varname" => "mastation_at_localhost__station", "altvarname" => "station", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "stationsodiserv1_audit", "varname" => "mastation_at_localhost__stationsodiserv1_audit", "altvarname" => "stationsodiserv1_audit", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "stocks", "varname" => "mastation_at_localhost__stocks", "altvarname" => "stocks", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "typecaisse", "varname" => "mastation_at_localhost__typecaisse", "altvarname" => "typecaisse", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "typemouvement", "varname" => "mastation_at_localhost__typemouvement", "altvarname" => "typemouvement", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "utilisateur", "varname" => "mastation_at_localhost__utilisateur", "altvarname" => "utilisateur", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "vente_du_jour", "varname" => "mastation_at_localhost__vente_du_jour", "altvarname" => "vente_du_jour", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "vente_du_mois", "varname" => "mastation_at_localhost__vente_du_mois", "altvarname" => "vente_du_mois", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "ventearticle", "varname" => "mastation_at_localhost__ventearticle", "altvarname" => "ventearticle", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "ventepompe", "varname" => "mastation_at_localhost__ventepompe", "altvarname" => "ventepompe", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
		$this->lstTables[] = array("name" => "versement_du_jour", "varname" => "mastation_at_localhost__versement_du_jour", "altvarname" => "versement_du_jour", "connId" => "mastation_at_localhost", "schema" => "", "connName" => "khadystations at localhost");
	}

	/**
      * Returns table object by table name.
      * @intellisense
      */
	function & Table($strTable, $schema = "", $connName = "")
	{
		$this->FillTablesList();
		foreach($this->lstTables as $tbl)
		{
			if(strtoupper($strTable)==strtoupper($tbl["name"]) &&
				( $schema == "" || strtoupper($schema) == strtoupper($tbl["schema"]) ) &&
				($connName == "" || strtoupper($connName) == strtoupper($tbl["connName"]) ) )
			{
				$this->CreateClass($tbl);
				return $this->{"tbl".$tbl["varname"]};
			}
		}
//	check table names without dbo. and other prefixes
		foreach($this->lstTables as $tbl)
		{
			if(strtoupper(cutprefix($strTable))==strtoupper(cutprefix($tbl["name"])))
			{
				$this->CreateClass($tbl);
				return $this->{"tbl".$tbl["varname"]};
			}
		}
		$dummy=null;
		return $dummy;
	}
	
	function CreateClass(&$tbl)
	{
		if($this->{"tbl".$tbl["varname"]})
			return;
//	load table info
		global $dal_info;
		include(getabspath("include/dal/".($tbl["varname"]).".php"));
//	create class and object

		$classname="class_".$tbl["varname"];
		$str = "class ".$classname." extends tDALTable  {";
		foreach($dal_info[$tbl["varname"]] as $fld)
		{
			$str.=' var $'.$fld["varname"].'; ';
		}
		
		$tableName = $tbl["name"];
		if( $tbl["schema"] )
			$tableName = $tbl["schema"] . "." . $tbl["name"];
		$str.=' function __construct()
			{
				$this->m_TableName = \''.escapesq( $tableName ).'\';
				$this->infoKey = \'' . $tbl["varname"] . '\';
				$this->setConnection(\''. $tbl["connId"] .'\');
			}
		};';
		eval($str);
		$this->{"tbl".$tbl["varname"]} = new $classname;
		$this->{$tbl["altvarname"]} = $this->{"tbl".$tbl["varname"]};
		$this->Table[$tbl["name"]]=&$this->{"tbl".$tbl["varname"]};
	}
	
	/**
      * Returns list of table names.
      * @intellisense
      */
	function GetTablesList()
	{
		$this->FillTablesList();
		$res=array();
		foreach($this->lstTables as $tbl)
			$res[]=$tbl["name"];
		return $res;
	}
	
	/**
      * Get list of table fields by table name.
      * @intellisense
      */
	function GetFieldsList($table)
	{
		$tbl = $this->Table($table);
		return $tbl->GetFieldsList();
	}
	
	/**
      * Get field type by table name and field name.
      * @intellisense
      */
	function GetFieldType($table,$field)
	{
		$tbl = $this->Table($table);
		return $tbl->GetFieldType($field);
	}

	/**
      * Get table key fields by table name.
      * @intellisense
      */
	function GetDBTableKeys($table)
	{
		$tbl = $this->Table($table);
		return $tbl->GetDBTableKeys();
	}
}

$dal = new tDAL;

/**
 * Data Access Layer table class.
 */ 
class tDALTable
{
	var $m_TableName;
	var $infoKey;
	var $Param = array();
	var $Value = array();
	/**
	 * @type Connection
	 */
	var $_connection;
	
	/**
	 * Set the connection property
	 * @param String connId
	 */
	function setConnection( $connId )
	{
		global $cman;
		$this->_connection = $cman->byId( $connId );
	}
	
	/**
      * Get table key fields.
      * @intellisense
      */
	function GetDBTableKeys()
	{
		global $dal_info;
		if( !array_key_exists($this->infoKey, $dal_info) || !is_array($dal_info[ $this->infoKey ]) )
			return array();
		
		$ret = array();
		foreach($dal_info[ $this->infoKey ] as $fname=>$f)
		{
			if( @$f["key"] )
				$ret[] = $fname;
		}
		return $ret;
	}
	
	/**
      * Get list of table fields.
      * @intellisense
      */
	function GetFieldsList()
	{
		global $dal_info;
		return array_keys( $dal_info[ $this->infoKey ] );
	}

	/**
      * Get field type.
      * @intellisense
      */
	function GetFieldType($field)
	{
		global $dal_info;
		
		if( !array_key_exists( $field, $dal_info[ $this->infoKey ]) )
			return 200;
			
		return $dal_info[ $this->infoKey ][ $field ]["type"];
	}
	
	/**
	 *
	 */
	function PrepareValue($value, $type)
	{
		if( $this->_connection->dbType == nDATABASE_Oracle || $this->_connection->dbType == nDATABASE_DB2 || $this->_connection->dbType == nDATABASE_Informix )
		{
			if( IsBinaryType($type) )
			{
				if( $this->_connection->dbType == nDATABASE_Oracle )
					return "EMPTY_BLOB()";
					
				return "?";
			}
			
			if( $this->_connection->dbType == nDATABASE_Informix  && IsTextType($type) )
				return "?";
		}
	
		if( IsDateFieldType($type) )
		{
			if( !$value )
				return "null";
			else
				$this->_connection->addDateQuotes( $value );
		}
		
		if( NeedQuotes($type) )
			return $this->_connection->prepareString( $value );

		return 0 + $value;
	}
	
	/**
      * Get table name.
      * @intellisense
      */
	function TableName()
	{
		return $this->_connection->addTableWrappers( $this->m_TableName );
	} 

	/**
	 * @param Array blobs
	 * @param String dalSQL
	 * @param Array tableinfo
	 */
	protected function Execute_Query($blobs, $dalSQL, $tableinfo)
	{		
		$blobTypes = array();
		if( $this->_connection->dbType == nDATABASE_Informix )
		{		
			foreach( $blobs as $fname => $fvalue )
			{
				$blobTypes[ $fname ] = $tableinfo[ $fname ]["type"];
			}
		}

		$this->_connection->execWithBlobProcessing( $dalSQL, $blobs, $blobTypes );
	}

	/**
      * Add new record to the table.
      * @intellisense
      */
	function Add() 
	{
		global $dal_info;
		
		$insertFields = "";
		$insertValues = "";
		$tableinfo = &$dal_info[ $this->infoKey ];
		$blobs = array();
		//	prepare parameters		
		foreach($tableinfo as $fieldname => $fld)
		{
			if( isset($this->{$fld['varname']}) )
			{
				$this->Value[ $fieldname ] = $this->{$fld['varname']};
			}
			
			foreach($this->Value as $field => $value)
			{
				if( strtoupper($field) != strtoupper($fieldname) )
					continue;
					
				$insertFields.= $this->_connection->addFieldWrappers( $fieldname ).",";
				$insertValues.= $this->PrepareValue($value,$fld["type"]) . ",";
				
				if( $this->_connection->dbType == nDATABASE_Oracle || $this->_connection->dbType == nDATABASE_DB2 || $this->_connection->dbType == nDATABASE_Informix )
				{
					if( IsBinaryType( $fld["type"] ) )
						$blobs[ $fieldname ] = $value;
						
					if( $this->_connection->dbType == nDATABASE_Informix && IsTextType( $fld["type"] ) )
						$blobs[ $fieldname ] = $value;
				}
				break;
			}
		}
		//	prepare and exec SQL
		if( $insertFields != "" && $insertValues != "" )		
		{
			$insertFields = substr($insertFields, 0, -1);
			$insertValues = substr($insertValues, 0, -1);
			$dalSQL = "insert into ".$this->_connection->addTableWrappers( $this->m_TableName )." (".$insertFields.") values (".$insertValues.")";
			$this->Execute_Query($blobs, $dalSQL, $tableinfo);
		}
		//	cleanup		
	    $this->Reset();
	}

	/**
      * Query all records from the table.
      * @intellisense
      */
	function QueryAll()
	{
		$dalSQL = "select * from ".$this->_connection->addTableWrappers( $this->m_TableName );
		return $this->_connection->query( $dalSQL );
	}

	/**
      * Do a custom query on the table.
      * @intellisense
      */
	function Query($swhere = "", $orderby = "")
	{
		if ($swhere)
			$swhere = " where ".$swhere;
			
		if ($orderby)
			$orderby = " order by ".$orderby;
			
		$dalSQL = "select * from ".$this->_connection->addTableWrappers( $this->m_TableName ).$swhere.$orderby;
		return $this->_connection->query( $dalSQL );
	}

	/**
      * Delete a record from the table.
      * @intellisense
      */
	function Delete()
	{
		global $dal_info;
		
		$deleteFields = "";
		$tableinfo = &$dal_info[ $this->infoKey ];
		//	prepare parameters		
		foreach($tableinfo as $fieldname => $fld)
		{
			if( isset($this->{$fld['varname']}) )
			{
				$this->Param[ $fieldname ] = $this->{$fld['varname']};
			}
			
			foreach($this->Param as $field => $value)
			{
				if( strtoupper($field) != strtoupper($fieldname) )
					continue;
					
				$deleteFields.= $this->_connection->addFieldWrappers( $fieldname )."=". $this->PrepareValue($value, $fld["type"]) . " and ";
				break;
			}
		}
		//	do delete
		if ($deleteFields)
		{
			$deleteFields = substr($deleteFields, 0, -5);
			$dalSQL = "delete from ".$this->_connection->addTableWrappers( $this->m_TableName )." where ".$deleteFields;
			$this->_connection->exec( $dalSQL );
		}
	
		//	cleanup
	    $this->Reset();
	}

	/**
      * Reset table object.
      * @intellisense
      */
	function Reset()
	{
		global $dal_info;
		
		$this->Value = array();
		$this->Param = array();
		
		$tableinfo = &$dal_info[ $this->infoKey ];
		//	prepare parameters		
		foreach($tableinfo as $fieldname => $fld)
		{
			unset($this->{$fld["varname"]});
		}
	}	

	/**
      * Update record in the table.
      * @intellisense
      */
	function Update()
	{
		global $dal_info;
		
		$tableinfo = &$dal_info[ $this->infoKey ];
		$updateParam = "";
		$updateValue = "";
		$blobs = array();

		foreach($tableinfo as $fieldname => $fld)
		{
			$command = 'if(isset($this->'.$fld['varname'].')) { ';
			if( $fld["key"] )
				$command.= '$this->Param[\''.escapesq($fieldname).'\'] = $this->'.$fld['varname'].';';
			else
				$command.= '$this->Value[\''.escapesq($fieldname).'\'] = $this->'.$fld['varname'].';';
			$command.= ' }';
			
			eval($command);
			
			if( !$fld["key"] && !array_key_exists( strtoupper($fieldname), array_change_key_case($this->Param, CASE_UPPER) ) )
			{
				foreach($this->Value as $field => $value)
				{
					if( strtoupper($field) != strtoupper($fieldname) )
						continue;
						
					$updateValue.= $this->_connection->addFieldWrappers( $fieldname )."=".$this->PrepareValue($value, $fld["type"]) . ", ";
					
					if( $this->_connection->dbType == nDATABASE_Oracle || $this->_connection->dbType == nDATABASE_DB2 || $this->_connection->dbType == nDATABASE_Informix )
					{
						if( IsBinaryType( $fld["type"] ) )
							$blobs[ $fieldname ] = $value;
							
						if( $this->_connection->dbType == nDATABASE_Informix && IsTextType( $fld["type"] ) )	
							$blobs[ $fieldname ] = $value;		
					}
					break;
				}
			}
			else
			{
				foreach($this->Param as $field=>$value)
				{
					if( strtoupper($field) != strtoupper($fieldname) )
						continue;
						
					$updateParam.= $this->_connection->addFieldWrappers( $fieldname )."=".$this->PrepareValue($value, $fld["type"]) . " and ";
					break;
				}
			}
		}

		//	construct SQL and do update	
		if ($updateParam)
			$updateParam = substr($updateParam, 0, -5);
		if ($updateValue)
			$updateValue = substr($updateValue, 0, -2);
			
		if ($updateValue && $updateParam)
		{
			$dalSQL = "update ".$this->_connection->addTableWrappers( $this->m_TableName )." set ".$updateValue." where ".$updateParam;
			$this->Execute_Query($blobs, $dalSQL, $tableinfo);
		}

		//	cleanup
		$this->Reset();
	}
	
	/**
	 * Select one or more records matching the condition
	 */
	function FetchByID()
	{
		global $dal_info;
		$tableinfo = &$dal_info[ $this->infoKey ];

		$dal_where = "";
		foreach($tableinfo as $fieldname => $fld)
		{
			$command = 'if(isset($this->'.$fld['varname'].')) { ';
			$command.= '$this->Value[\''.escapesq($fieldname).'\'] = $this->'.$fld['varname'].';';
			$command.= ' }';
			
			eval($command);
			
			foreach($this->Param as $field => $value)
			{
				if( strtoupper($field) != strtoupper($fieldname) )
					continue;
					
				$dal_where.= $this->_connection->addFieldWrappers( $fieldname )."=".$this->PrepareValue($value, $fld["type"]) . " and ";
				break;
			}
		}
		// cleanup
		$this->Reset();
		// construct and run SQL
		if ($dal_where)
			$dal_where = " where ".substr($dal_where, 0, -5);
			
		$dalSQL = "select * from ".$this->_connection->addTableWrappers( $this->m_TableName ).$dal_where;
		return $this->_connection->query( $dalSQL );
	}
}

function cutprefix($table)
{
	$pos = strpos($table,".");
	if( $pos === false )
		return $table;
		
	return substr($table, $pos + 1);
}

function escapesq($str)
{
	return str_replace(array("\\","'"),array("\\\\","\\'"),$str);
}

?>